#include <stdio.h>
#include <stdlib.h>
#include <vga.h>
#include <vgakeyboard.h>
#include <mlvalues.h>
#include <alloc.h>
#include <memory.h>

extern unsigned char *graph_mem ;
double *GfxDest ;

value vga_lores_init ()
{
  vga_init () ;
  if (vga_setmode (G320x200x256) == -1) failwith ("vga_setmode") ;
  /* INIT PAR EFFET DE BORD, DE L'ADRESSE DE LA PAGE VGA */
  /* CONSIDEREE COMME UN TABLEAU DE 64000/8 doubles      */
  GfxDest = (double*) graph_mem ;
  return (Val_unit) ;
}


value vga_keyboard_init ()
{
  if (keyboard_init () == -1) failwith ("keyboard_init") ;
  return (Val_unit) ;
}


value vga_blit_buffer (StringBuffer)
     value StringBuffer ;
{

#ifdef BCOPY_BLIT
  // vga_waitretrace() ;
  bcopy (StringBuffer, graph_mem, 64000) ;
#else
  unsigned short Index ;
  double *GfxSrc = (double*) StringBuffer ;

  vga_waitretrace() ;
  for (Index=0;Index<8000;Index++)
    GfxDest[Index] = GfxSrc[Index] ;
#endif

  return (Val_unit) ;
}


value vga_keyboard_close ()
{
  keyboard_close () ;
  return (Val_unit) ;
}

value vga_lores_close ()
{
  vga_setmode (TEXT) ;
  return (Val_unit) ;
}


value vga_keyboard_update ()
{
  keyboard_update () ;
  return (Val_unit) ;
}


value vga_keyboard_keypressed (ScanCode)
     value ScanCode ;
{
  if (keyboard_keypressed (Int_val (ScanCode)))
   return (Val_int(1)) ;  /* TRUE */
  else
   return (Val_int(0)) ;  /* FALSE */
}


value vga_setpalette_entry (Index, RedComp, GreenComp, BlueComp)
     value Index ;
     value RedComp, GreenComp, BlueComp  ;
{
  vga_setpalette (Int_val (Index), Int_val (RedComp), Int_val (GreenComp),
			   Int_val (BlueComp)) ;
  return (Val_unit) ;
}

