(* ******** *)
(* VERTEXES *)
(* ******** *)
type t_Vertex = {
 mutable x : float ;   (* ABSCISSE DU VERTEX *)
 mutable y : float     (* ORDONNEE DU VERTEX *)
 };;


(* ********************************************************************* *)
(* VERTEX VIDE : SERT A L'INITIALISATION DE LA TABLE GLOBALE DE VERTEXES *)
(* ********************************************************************* *)
let emptyVertex = { x = 0.0 ; y = 0.0 } ;;


(* ****************************************************** *)
(* TABLE GLOBALE DE VERTEXES INDEXEE PAR NUMERO DE VERTEX *)
(* ****************************************************** *)
let globalvertextable = Array.create 400 emptyVertex ;;


(* *************************************** *)
(* NOMBRE ACTUEL DE VERTEXES DANS LE MONDE *)
(* *************************************** *)
let nbVertexes = ref 0 ;;


(* ******************************************************************* *)
(* FONCTION QUI RAJOUTE UN VERTEX DANS LA TABLE ET RETOURNE SON NUMERO *)
(* ******************************************************************* *)
let addVertex v =
 globalvertextable.(!nbVertexes) <- v ;
 let tmp = !nbVertexes in
  nbVertexes := !nbVertexes + 1 ;
  tmp
;;

