(* ********* *)
(* ARBRE BSP *)
(* ********* *)
type t_Tree =
   Leaf of int list           (* FEUILLE : LISTE DE NUMEROS DE LIGNES *)
 | Node of t_Node             (* NOEUD DE SOUS-ARBRE *)

(* ***** *)
(* NOEUD *)
(* ***** *)
and t_Node = {
 partline : int ;  (* NUMERO DE LIGNE DE PARTITION *)
 leftbbox : (float*float*float*float) option ; (* MIN, MAX *)
 left : t_Tree ;   (* SOUS-ARBRE GAUCHE *)
 rightbbox : (float*float*float*float) option ; (* MIN, MAX *)
 right : t_Tree    (* SOUS-ARBRE DROIT *)
} ;;



let levelBspTree = ref (Leaf []) ;;
